import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.*; 
import peasy.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Wormhout10Chain3 extends PApplet {

// Wormhout10Chain3.pde
// OuvertureXml.pde
// Chain.pde
// 
// Gerard Paresys Guy Kayser
// 6 1 2015
// Processing 2.0.3
//
// A partir de http://www.openprocessing.org/sketch/77718
// "Worm" de Adam Lastowka
// "A worm, building a landscape by "tunneling" all over it, raising and lowering the terrain.
// Somewhat like the sandworms in "Dune" by Frank Herbert,
// except for the rainbows and strange fading trails."
// en remplacant Maker[] Worm = new Maker[1];
// par             Maker Worm = new Maker(); (1 seul worm)
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)
// Touche Clavier:
//       E Erosion Lissage
//       R Reset
//       C Couleur Worm
//       S Sauve l'ecran (format png)
//       L Lumiere
//  Espace Pause
//
// Si le dossier data contient 5 fichiers nomm\u00e9s:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
//   XXX256.png  256x256 pixels
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre, choisir alors un fichier XXX.xml...
// Modifier la ligne 53 au besoin
//
// Le dossier data doit aussi contenir les fichiers:
//   ArialMT-12.vlw
//   Aller-Light-120.vlw
//

         // pour AudioPlayer


String  NomFichierXML = "maore.xml"; // les 5 fichiers "maore..." doivent etre dans le dossier data

boolean Lumiere    = true;
// boolean AfficheT   = false;        // Chrono
Boolean Couleur    = false;
boolean Verbose    = false;

XML[] Traduction, Transcription;
int NombreSegment;
String[] LignesPitch;
String[] LignesIntensity;
float[] LignePitch, LigneIntensity;
boolean FichierOuvert = false;

Minim minim;
AudioPlayer player;

PeasyCam pcam;

float[][] hm  = new float[256][256]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[256][256];
int hmlengthdemi = hm.length / 2;

float  M = 2;          // M = diametre du worm

boolean Pause = false;
float Temps, TempsPause = 0, TempsDebutPause = 0;
PFont  maFonte;


Maker Worm = new Maker(); 
float wormTemp;
int   x, y, Alea;
float Distance, h;

PImage Image1;
int MonPixel;

int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String Content1 = "", Content2 = "", Content = "", Nom = "";
float Intensite;
float  Facteur;


public void setup() {  
  size(800, 600, P3D); // P3D  OPENGL

  // Image1 = loadImage(NomFichierCarte);
  // background(Image1);
  // image(Image1, 0, 0, width, height);

  pcam = new PeasyCam(this, width/2, height/2, 0, 500); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  pcam.setMinimumDistance(50);
  pcam.setMaximumDistance(1000);
  pcam.rotateX(-PI/4);

  noStroke();
  // generateLandscape();

  // colorMode(HSB); // RGB  HSB
  frameRate(60);
  // frameRate(2); // A mettre pour mieux comprendre
  // maFonte = createFont("AdventPro-Thin", 12);
  // maFonte = createFont("Georgiazut", 18);
  maFonte = loadFont("ArialMT-12.vlw");

  println("hm.length = " + hm.length);

  // Chain ------------------------------------------------------------------------
  // Ruban = loadStrings("kokot.txt");
  Ruban = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
  reversed = reverseWords(Ruban);
  font = loadFont("Aller-Light-120.vlw"); // Font taille 120
  chain = new ArrayList();
  // chain = ("");
  for (int i = 0; i < num; i++) chain.add(new Chain(i));
  // Chain ------------------------------------------------------------------------

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) {
    Ouverture(NomFichierXML);
    Nom = split(Fichier.getName(), '.')[0];
  }
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
}

public void draw() {
  background(100, 100, 200);
  // image(Image1, 0, 0);
  // image(Image1, 0, 0, width, height);
  if (Lumiere) lights();

  if (! Pause) Temps = (millis() - TempsPause) / 1000.0f; //temps en ms

  if (FichierOuvert) {

    if (IndexXML < (NombreSegment-1)) {
      if (Temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        Content = Traduction[IndexXML].getContent();
        Content2 = Transcription[IndexXML].getContent();
        if (Verbose) println();
        if (Verbose) println("IndexXML = " + IndexXML);
        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((Temps > xmin) && ! Pause) {
        else if (! Pause) {
          Segment = Traduction[IndexXML].getInt("n"); 
          xmin = Traduction[IndexXML].getFloat("xmin");
          xmax = Traduction[IndexXML].getFloat("xmax");
          Content1 = trim(Content);
          Content2 = trim(Content2);
          println(Content1);
          println(Content2);

          // Chain ------------------------------------------------------------------------
          // Ruban[0] = Content2;
          // Ruban ="AZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTYAZERTY";
          // Ruban = loadStrings("kokot.txt");
          Ruban = Content2;
          reversed = reverseWords(Ruban);
          chain = new ArrayList();
          for (int i = 0; i < num; i++) chain.add(new Chain(i));
          // Chain ------------------------------------------------------------------------
        }
      }
    }
    else Pause = true;



    if (Temps < LignesIntensity.length) {
      LigneIntensity = PApplet.parseFloat(split(LignesIntensity[PApplet.parseInt(Temps * Facteur)], "   "));
      Intensite = LigneIntensity[1];
      Intensite = (Intensite - 40) / 12;
      Intensite = max(Intensite, 0);
      // println("Temps = " + Temps + "      Intensite = " + Intensite);
    }

    pushMatrix();
    translate(width/2, height/2);
    if (! Pause) {   
      temGen();
    }
    paintLandscape();
    // Lissage();
    textFont(maFonte, 12); 
    fill(0, 255, 0); // Texte vert
    textAlign(CENTER);
    // text(Content1, 0, 170, 60 ); // Traduction
    translate(-200, 0, 60);
    // text(Content1, 0, 220, 400, 100 ); // Traduction
    text(Content2, 0, 220, 400, 100 ); // Transcription
    popMatrix();

    // Chain ------------------------------------------------------------------------
    pushMatrix();
    translate(0, 0, 70);
    // noStroke(); // Commenter pour voir le dessin du ruban
    if (! Pause) {
      for (int i =0 ; i < chain.size();i++) {
        Chain cc  = (Chain)chain.get(i);
        cc.update();
      }
    }
    for (int i =chain.size()-1 ; i > 0 ;i--) {
      Chain cc  = (Chain)chain.get(i);
      cc.draww();
    }

    popMatrix();
    // Chain ------------------------------------------------------------------------
  }

  frame.setTitle(Nom + "     " + PApplet.parseInt(Temps * 10) / 10.0f + " sec     " + PApplet.parseInt(10 * frameRate) / 10.0f + " fps");
}

public void keyPressed() {
  if      ( key == ' '               ) {  // barre d'espace
    Pause = !Pause;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else if ( key == 'e' || key == 'E' ) Lissage(); // Erosion Lissage
  else if ( key == 'r' || key == 'R' ) {
    generateLandscape();
    xmax = 0;
    IndexXML = -1;
    Pause = false;
    TempsPause = millis();
    PlayerAudioDebut();
  }
  else if ( key == 'c' || key == 'C' ) Couleur = !Couleur;    // Touche C   Worm rouge
  //  else if ( key == 's' || key == 'S' ) saveFrame("Screen" + frameCount + ".png");
  else if ( key == 's' || key == 'S' ) saveFrame(Nom + "-" + frameCount + ".png");
  else if ( key == 'l' || key == 'L' ) Lumiere = !Lumiere;    // Touche L        Lumiere
  //  else if ( key == 't' || key == 'T' ) AfficheT = !AfficheT;  // Touche T        Affiche Temps en bas a droite
  // else if ( key == 'p' || key == 'P' ) Pause = !Pause;        // Touche P    Pause
}

public void generateLandscape() {
  Image1 = loadImage(NomFichierCarte);
  Image1.loadPixels();
  HeightMap();
  // for (int i = 0; i < 600; i++) temGen();
}

public void HeightMap() {
  for ( x = 0; x < hm.length; x++) {
    for ( y = 0; y < hm.length; y++) {
      // hm[x][y] = 0;
      // hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 255.f;
      // hm[x][y] = brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f;
      hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
      // println(brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f);
      // if (x == 128) {
      // println("generateLandscape  hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
      // }
    }
  }
  // for (int i = 0; i < 600; i++) temGen();
}

public void temGen() {
  // - hmlengthdemi < Worm.x < + hmlengthdemi
  // - hmlengthdemi < Worm.yx < + hmlengthdemi
  //  Worm.x += sin(Worm.wormTheta)*2;
  //  Worm.y += cos(Worm.wormTheta)*2;
  Worm.x += sin(Worm.wormTheta);
  Worm.y += cos(Worm.wormTheta);
  Worm.wormTheta += Worm.wormThetaDelta;
  Worm.wormThetaDelta += random(-0.1f, 0.1f);
  // Worm.wormThetaDelta /= 1.05; 
  Worm.wormThetaDelta /= 1.30f; // 1.05 le worm tourne beaucoup 1.25 tourne peu  Mettre 1.20
  if      (Worm.x >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.x < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;

  // Alea = int(random(hm.length));

  x = PApplet.parseInt(Worm.x + hmlengthdemi);
  y = PApplet.parseInt(Worm.y + hmlengthdemi);
  h = Intensite * 3.0f;
  // h = 20;
  hm[x][y] = hm[x][y] + h*1.5f;
  x = x - 1;
  hm[x][y] = hm[x][y] + h;
  x = x + 2;
  hm[x][y] = hm[x][y] + h;
  x = x - 1;
  y = y - 1;
  hm[x][y] = hm[x][y] + h;
  y = y + 2;
  hm[x][y] = hm[x][y] + h;

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x - hmlengthdemi) / M, (y - hmlengthdemi) / M, Worm.x / M, Worm.y / M);

      if (Distance < 3) {
        hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
        // Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 8)+255, (hm2[x][y] * 8), (hm2[x][y] * 8));
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] *8), 0, 0);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 16), (hm2[x][y] * 8), (hm2[x][y] * 8));

        if (Couleur)  Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] *8), 0, 0);
        else Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8);
      }
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x - hmlengthdemi) / M, (y - hmlengthdemi) / M, Worm.x / M, Worm.y / M);
      if (Distance < 3) {
        hm[x][y] = hm2[x][y];
      }
    }
  }

  // HeightMap();
  // Image1.updatePixels();
  // Lissage();
}

public void paintLandscape() {
  // stroke(128);
  noStroke();
  // fill(0,0,255); 
  scale(2);
  for ( x = 3; x < hm.length-5; x++) {
    beginShape(QUADS);
    for ( y = 3; y < hm.length-5; y++) {
      // fill(abs(4*hm[x][y]), 255, 255);//origin
      fill(Image1.pixels[x + (y * hm.length)]);
      vertex(x     - hmlengthdemi, y     - hmlengthdemi, hm[x]  [y]);
      vertex(x + 1 - hmlengthdemi, y     - hmlengthdemi, hm[x+1][y]);
      vertex(x + 1 - hmlengthdemi, y + 1 - hmlengthdemi, hm[x+1][y+1]);
      vertex(x     - hmlengthdemi, y + 1 - hmlengthdemi, hm[x]  [y+1]);
    }
    endShape(CLOSE);
  }
  scale(0.5f);
}


public void Lissage() {
  //    for(float x = 1; x < hm.length-1; x++) {
  //        for(float y = 1; y < hm.length-1; y++) {
  //          hm[(int)x][(int)y] = (hm[(int)x][(int)y]*2 + hm[(int)x+1][(int)y] + hm[(int)x-1][(int)y] + hm[(int)x][(int)y+1] + hm[(int)x][(int)y-1])/6;
  //        }
  //    }

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm[x][y] = hm2[x][y];
    }
  }
  println("Lissage");
}


class Maker {
  float x;
  float y;
  float wormTheta;
  float wormThetaDelta;
}

public void FinOuverture() {
  minim = new Minim(this);
  player = minim.loadFile(NomFichierAudio, 1024);
  FichierOuvert = true;
  xmax = 0;
  IndexXML = -1;
  Facteur = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 

  Lissage();
  Lissage();
  player.play();
  TempsPause = millis();
}

public void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 1024);
  player.play();
  TempsPause = millis();
}

//void AfficheTemps(float T) {
//  fill(255);
//  textFont(maFonte, 12);
//  textAlign(LEFT);
//  text(int(T * 10) / 10.0 + " sec   frameRate = "+ (int(10 * frameRate)) / 10.0 + "/sec", -200, 150, 60);
//}

// Chain.pde
// 4 1 2015
// d'apres Pesek Krystof (Kof)
// http://www.openprocessing.org/sketch/57362
// Dada data dada data code by kof 2012
//

ArrayList chain = new ArrayList();
PFont font;
// String Ruban={ "a", "b" }, plain, reversed;
String Ruban, plain, reversed;
int num = 50; // 400 nb de lettres


class Chain {

  PVector pos;
  Chain n;
  int id;
  float d, theta;
  float x1, x2, y1, y2;
  PGraphics mapa;


  Chain(int _id) {
    id = _id;
    if (id==0) n = this;
    else n = (Chain)chain.get(id-1);

    mapa = createGraphics(120, 120, JAVA2D); // fond du texte: P2D opaque, JAVA2D transparent
    // Chaque caract\u00e8re du texte en Font 120 va etre dessine au centre d'un carre 120x120

    mapa.beginDraw();
    mapa.textFont(font, 120); // 110
    mapa.fill(255, 0, 0); // Texte rouge
    mapa.textAlign(CENTER);
    mapa.text(reversed.charAt(reversed.length()-1-(id%reversed.length())), mapa.width/2, mapa.height-30);
    mapa.endDraw();

    theta = 0;
    pos = new PVector(-90, height/2);
  }

  public void update() {
    if (id==0) {
      pos.x += (mouseX-pos.x)/1.1f;
      pos.y += (mouseY-pos.y)/1.1f;
    }
    else {
      pos.x += (n.pos.x-pos.x)/(10.1f);
      pos.y += (n.pos.y-pos.y)/(10.1f);
      // d = noise(id/30.0)*96*2;//
      //d += (n.d-d)/10.001;
      d = dist(pos.x, pos.y, n.pos.x, n.pos.y);//(dist(pos.x, pos.y, n.pos.x, n.pos.y)-d)/20.1; 
      theta = atan2(n.pos.y-pos.y, n.pos.x-pos.x);
    }

    pushMatrix();
    translate((pos.x + n.pos.x) * 0.5f, (pos.y + n.pos.y) * 0.5f);
    x1 = screenX(cos(theta+QUARTER_PI)*d, sin(theta+QUARTER_PI)*d);
    y1 = screenY(cos(theta+QUARTER_PI)*d, sin(theta+QUARTER_PI)*d);
    x2 = screenX(cos(theta-QUARTER_PI)*d, sin(theta-QUARTER_PI)*d);
    y2 = screenY(cos(theta-QUARTER_PI)*d, sin(theta-QUARTER_PI)*d);
    popMatrix();
  }

  public void draww() {
    // fill(0, 0);
    // noStroke();
    // noFill();  // When textures are in use, the fill color is ignored
    beginShape();
    tint(255, d*12); // Apply transparency without changing color
    texture(mapa);
    vertex(x2, y2, 0, 0);
    vertex(n.x2, n.y2, mapa.width, 0);
    vertex(n.x1, n.y1, mapa.width, mapa.height);
    vertex(x1, y1, 0, mapa.height);
    endShape(CLOSE);
  }
}


public String reverseWords(String input) {
  String in = "";
  // for (int i =0 ; i < input.length();i++) in += input[i]+" ";
  in = input;
  //  String tmp = splitTokens(in, " ");
  //  String out = "";
  //  for (int i = 0;i<tmp.length();i++) out += new StringBuffer(tmp[i]).reverse().toString() +" ";
  //  out = new StringBuffer(out).reverse().toString();
  //  return out;
  return input;
}

// OuvertureXml.pde
// 
// Gerard Paresys Guy Kayser
// 3 1 2015
// Processing 2.0.3
//

// String[] list;
XML xml1, kid1, kid2;
XML[] kid1Data, kidkid1Data, kidkid1intervals, kidkid1intervalsxmax;
String DebutNomFichier     = "";
String NomFichierPitch     = "XXX_Pitch.txt";
String NomFichierIntensity = "XXX_Intensity.txt";
String NomFichierAudio     = "XXX.mp3";
String NomFichierCarte     = "XXX.png";
float DureeFichier;

public void fileSelected(File FichierChoisi) {
  if (FichierChoisi == null) {
    println("1 Pas de fichier XXX.xml ouvert!");
    exit();
  } 
  else {
    Ouverture(FichierChoisi.getAbsolutePath());
    Nom = split(FichierChoisi.getName(), '.')[0];
  }
}


public void Ouverture(String NomFichier) {
  boolean Probleme = false;

  File Fichier = new File(dataPath(NomFichier));
  if (!Fichier.exists()) { 
    println("2 Le fichier " + NomFichier + " n'existe pas");
    Probleme = true;
  }
  else println("Selection:    " + NomFichier);

  if (!Probleme) {
    // list = split(NomFichier, '.');
    // NomFichierXML = list[0] + ".xml";
    // DebutNomFichier = join(shorten(list), ".");
    DebutNomFichier = join(shorten(split(NomFichier, '.')), "."); // A cause des path avec plusieurs .
    NomFichierXML = DebutNomFichier + ".xml";

    if (loadStrings(NomFichierXML) == null) { 
      println("3 Le fichier " + NomFichierXML + " n'existe pas");
      Probleme = true;
    }
  }

  if (!Probleme) {
    xml1 = loadXML(NomFichierXML);  //Processing 2.0
    println("Ouverture de: " + NomFichierXML);
    if (Verbose) println("1-----------------------------------------------------------");
    // NombreDeChild1 = xml1.getChildCount();
    if (xml1.hasChildren()) { 
      //  println("xml1.hasChildren");
      if (Verbose) println("xml1.listChildren() : ");
      if (Verbose) println(xml1.listChildren());
    } 
    else {
      println("4 Le fichier xml n'a pas le bon format");      
      Probleme = true;
    }
  }

  if (!Probleme) {
    if (!(xml1.listChildren()[1] == "items" )) {
      println("5 Le fichier xml n'a pas le bon format");
      Probleme = true;
    }
  }

  if (!Probleme) {
    kid1Data = xml1.getChildren("items");
    //    println("2-----------------------------------------------------------");
    //    println(kid1Data);
    kidkid1Data = kid1Data[0].getChildren("item");
    //      s2 = kidkid1Data[1].getName();
    //      println("s2 = " + s2);
    if (Verbose) println("kidkid1Data-----------------------------------------------------------");
    if (Verbose) println(kidkid1Data);  // gros a lister
    if (Verbose) println("-----------------------------------------------------------");
    if (Verbose) println("Length of kidkid1Data = " + kidkid1Data.length);
    if (Verbose) println("kidkid1Data[0].getName() = " + kidkid1Data[0].getName());
    if (Verbose) println("kidkid1Data[1].getName() = " + kidkid1Data[1].getName());
    if (Verbose) println("kidkid1Data[0].listAttributes() = " + kidkid1Data[1].getChildren("item"));

    //    kidkid1intervals = kidkid1Data[4].getChildren("intervals");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println(kidkid1intervals);
    //    println("-----------------------------------------------------------");
    //    println("Length of kidkid1intervals = " + kidkid1intervals.length);
    //    println("kidkid1intervals[10].getName() = " + kidkid1intervals[10].getName());
    //    println("kidkid1intervals[11].getName() = " + kidkid1intervals[11].getName());
    //    println("kidkid1intervals.listAttributes() = " + kidkid1intervals[10].getChildren("intervals"));
    //
    //    // kidkid1intervalsxmax = kidkid1intervals[76].getChildren("xmax");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println("kidkid1intervals[26].getInt(\"n\")      = " + kidkid1intervals[26].getInt("n"));
    //    println("kidkid1intervals[26].getFloat(\"xmax\") = " + kidkid1intervals[26].getFloat("xmax"));
    //    println("kidkid1intervals[26].getFloat(\"xmin\") = " + kidkid1intervals[26].getFloat("xmin"));
    //    println("kidkid1intervals[26].getContent()     = " + kidkid1intervals[26].getContent());
    //    println();
    //    println("kidkid1intervals[27].getFloat(\"xmax\") = " + kidkid1intervals[27].getFloat("xmax"));
    //    println("-----------------------------------------------------------");
    //      println("Length of kidkid1intervalsxmax = " + kidkid1intervalsxmax.length);
    //      println("kidkid1intervalsxmax[10].getName() = " + kidkid1intervalsxmax[10].getName());
    //      println("kidkid1intervalsxmax[11].getName() = " + kidkid1intervalsxmax[11].getName());
    //      println("kidkid1intervalsxmax.listAttributes() = " + kidkid1intervalsxmax[10].getChildren("intervals"));
    //    fill(0);
    //    textFont(maFonte, 16);
    //    fill(180);
    //    textFont(maFonte, 12);
    //    text(NomFichierXML, 10, 65);

    Traduction = kidkid1Data[0].getChildren("intervals");
    NombreSegment = Traduction.length;
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");
    // println(Traduction);  // gros a lister
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");

    Transcription = kidkid1Data[1].getChildren("intervals");
    if (NombreSegment != Transcription.length ) {
      println("6 Le fichier xml n'a pas le bon format");
      println("6 il n'y a pas le meme nombre de segment transcrit et traduit");
      Probleme = true;
    }
  } 

  if (! Probleme) {    
    // NomFichierPitch = list[0] + "_Pitch.txt";
    NomFichierPitch = DebutNomFichier + "_Pitch.txt";
    if (loadStrings(NomFichierPitch) == null) { 
      println("7 Le fichier " + NomFichierPitch + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesPitch = loadStrings(NomFichierPitch);
      println("Ouverture de: " + NomFichierPitch +"  " + LignesPitch.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    // NomFichierIntensity = list[0] + "_Intensity.txt";
    NomFichierIntensity = DebutNomFichier + "_Intensity.txt";
    if (loadStrings(NomFichierIntensity) == null) { 
      println("8 Le fichier " + NomFichierIntensity + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesIntensity = loadStrings(NomFichierIntensity);
      println("Ouverture de: " + NomFichierIntensity +"  " + LignesIntensity.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    // NomFichierAudio = list[0] + ".mp3";
    NomFichierAudio = DebutNomFichier + ".mp3";
    if (loadStrings(NomFichierAudio) == null) { 
      println("9 Le fichier " + NomFichierAudio + " n'existe pas");
      Probleme = true;
    } 
    else println("Ouverture de: " + NomFichierAudio);
  }

  if (! Probleme) { 
    // NomFichierCarte = list[0] + "256.png";
    NomFichierCarte = DebutNomFichier + "256.png";
    if (loadStrings(NomFichierCarte) == null) { 
      println("10    Le fichier " + NomFichierCarte + " n'existe pas");
      Probleme = true;
    } 
    else {
      println("Ouverture de: " + NomFichierCarte);
      generateLandscape();
    }
  }

  if (! Probleme) { 
    println("NombreSegment = " + NombreSegment); 

    LignePitch = PApplet.parseFloat(split(LignesPitch[LignesPitch.length - 1 ], "   "));
    DureeFichier = LignePitch[0];
    if (Verbose) println("Duree " + NomFichierPitch + " = " + DureeFichier + " sec");

    LigneIntensity = PApplet.parseFloat(split(LignesIntensity[LignesIntensity.length - 1 ], "   "));
    DureeFichier = LigneIntensity[0];
    if (Verbose) println("Duree " + NomFichierIntensity + " = " + DureeFichier + " sec");

    FinOuverture();
  }
  else exit();
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Wormhout10Chain3" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
